# -*- coding: utf-8 -*-
import json
import sentiment_analysis_functions as sfun

# installation
# import nltk
# nltk.download('punkt')
# nltk.download('wordnet')
# nltk.download('stopwords')
# nltk.download('averaged_perceptron_tagger')
# nltk.download('universal_tagset')

# from sklearn.feature_extraction.text import CountVectorizer
# from sklearn.naive_bayes import MultinomialNB
# from sklearn.linear_model import LogisticRegression

train_pos_reviews_fn = "./data/train-positive-t1.txt"
train_neg_reviews_fn = "./data/train-negative-t1.txt"
test_pos_reviews_fn = "./data/test-pos-t1.txt"
test_neg_reviews_fn = "./data/test-neg-t1.txt"


# Aucune contrainte pour cette tâche. Vous pouvez structurez votre code comme bon vous semble.
# Expliquez dans votre rapport comment exécuter le code et définir les configurations.


def load_reviews(filename):
    with open(filename, 'r') as fp:
        reviews_list = json.load(fp)
    return reviews_list


if __name__ == '__main__':
    train_positive_reviews = load_reviews(train_pos_reviews_fn)
    train_negative_reviews = load_reviews(train_neg_reviews_fn)
    test_positive_reviews = load_reviews(test_pos_reviews_fn)
    test_negative_reviews = load_reviews(test_neg_reviews_fn)
    print("Nb of training reviews - positive:", len(train_positive_reviews), "negative:", len(train_negative_reviews))
    print("Nb of test reviews - positive:", len(test_positive_reviews), "negative:", len(test_negative_reviews))

    x0 = sfun.tokenize(train_positive_reviews)
    x1 = sfun.norm_stemming(x0)
    x2 = sfun.norm_lemmatize(x0)

    x11 = sfun.select_freq(x1)
    x21 = sfun.select_freq(x2)

    x12 = sfun.select_rem_stopwords(x1)
    x22 = sfun.select_rem_stopwords(x2)

    x13 = sfun.select_open_class(x1)
    x23 = sfun.select_open_class(x2)
    
    x11c = sfun.corpus_documents(x11)
    x21c = sfun.corpus_documents(x21)
    x12c = sfun.corpus_documents(x12)
    x22c = sfun.corpus_documents(x22)
    x13c = sfun.corpus_documents(x13)
    x23c = sfun.corpus_documents(x23)
    
    x111 = sfun.value_count(x11c)
    x211 = sfun.value_count(x21c)
    x121 = sfun.value_count(x12c)
    x221 = sfun.value_count(x22c)
    x131 = sfun.value_count(x13c)
    x231 = sfun.value_count(x23c)
    
    x112 = sfun.value_occurence(x11c)
    x212 = sfun.value_occurence(x21c)
    x122 = sfun.value_occurence(x12c)
    x222 = sfun.value_occurence(x22c)
    x132 = sfun.value_occurence(x13c)
    x232 = sfun.value_occurence(x23c)
    
    x113 = sfun.value_tfidf(x11c)
    x213 = sfun.value_tfidf(x21c)
    x123 = sfun.value_tfidf(x12c)
    x223 = sfun.value_tfidf(x22c)
    x133 = sfun.value_tfidf(x13c)
    x233 = sfun.value_tfidf(x23c)